#if !defined(__laskrapp_h)              // Sentry, use file only if it's not already included.
#define __laskrapp_h

/*  Project laskuri
    
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    laskuri.exe Application
    FILE:         laskrapp.h
    AUTHOR:       


    OVERVIEW
    ========
    Class definition for laskuriApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\opensave.h>

#include "laskrapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = SDIDecFrame}}
class SDIDecFrame : public TDecoratedFrame {
public:
    SDIDecFrame (TWindow *parent, const char far *title, TWindow *clientWnd, BOOL trackMenuSelection = FALSE, TModule *module = 0);
    ~SDIDecFrame ();
};    //{{SDIDecFrame}}


//{{TApplication = laskuriApp}}
class laskuriApp : public TApplication {
private:
    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.

public:
    laskuriApp ();
    virtual ~laskuriApp ();

    void OpenFile (const char *fileName = 0);
//{{laskuriAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
//{{laskuriAppVIRTUAL_END}}

//{{laskuriAppRSP_TBL_BEGIN}}
protected:
    void CmFileNew ();
    void CmFileOpen ();
    void CmFileClose ();
    void CmHelpAbout ();
//{{laskuriAppRSP_TBL_END}}
  DECLARE_RESPONSE_TABLE(laskuriApp);
};    //{{laskuriApp}}


#endif                                      // __laskrapp_h sentry.
