/*
    Malliesimerkki perimisest.

    Ohjelma matkii graafisia olioita, mutta todelliset
    piirtmiset tehdnkin tulostuksina olion ominaisuuksista.

    Kaikki voisivat olla mys void tyyppi, mutta joissakin
    tapauksissa niit pstn helpommin kutsumaan, mikli ne
    paluattavat jotakin.  Paluu arvoksi on nyt valittu
    tieto siit, onko objekti nkyviss vai ei.

    Tehtvi:
      1) Kokeile ottaa virtual pois pisteen piirra-funktiosta.
         Mit tapahtuu?

      2) Lis luokka nelio, jolla r merkitsee sivun pit. puolikasta.

      3) Olisi kivaa, mikli kukin olio syttyisi automaattisesti
         kun olio luodaan.  Konstruktorissa ei kuitenkaan voida
         kuitenkaan kutsua virtuaalisia funktioita, eik muutenkaan
         voitaisi est (yksinkertaisesti) esim. ympyrn keskipisteen
         syttymist.  Kokeile list automaattinen sytytys
         luokkaan piste.  Mit tapahtuu?

      4) Edellinen ongelma voitanee korjata seuraavasti:
         Kirjoita luokat: keskipiste - kuten piste nyt,
                          piste      - sytytt automaattisesti
                          pistesade  - kuten ympyr nyt
                          ympyra     - syttyy automaattisesti
                          nelio      - syttyy automaattisesti

vl 19.10.1992

*/
#include <stdio.h>
#include <string.h>

//****************************************************************************
enum tilat{           // Onko piste sytytetty vai sammutettu
  sammutettu,
  sytytetty
};

char *Tilat[] = {"Sammutettu","Sytytetty"};

class piste {
protected:            // Jos halutaan peri luokka, pit yht. osien olla prot
  int x,y;               // Koordinaatit
  char nimi[20];         // Nimi, jotta ostataan tulostaa mist oliosta kyse
  tilat tila;            // Sytytetty vai sammutettu
  int vaihda_paikka(int nx, int ny);
public:
  piste(char *s="piste",int ix=0,int iy=0) {
    tila=sammutettu;
    x=ix; y=iy; strcpy(nimi,s);
  }
  ~piste() { sammuta(); }// Poistetaan olio aina lopuksi, nyt voi kutsua virt.
  int nakyvissa();       // Onko olio nkyviss
  int sammuta();         // Poistaa olion nytst
  int sytyta();          // Sytytt olion nyttn
  int siirra(int nx=0,int ny=0);
  virtual int piirra() { // Suorittaa olion todellisen piirtmisen, oma jok.
    printf("Piste : %-10s %-10s:(%02d,%02d)\n",Tilat[tila],nimi,x,y);
    return nakyvissa();
  }
};

int piste::vaihda_paikka(int nx, int ny)
{
  x = nx; y = ny;
  return ( tila == sytytetty );
}

int piste::nakyvissa()
{
  return ( tila == sytytetty );
}

int piste::sammuta()
{
  if ( !nakyvissa() ) return 0;
  tila=sammutettu;
  return piirra();
}

int piste::sytyta()
{
  if ( nakyvissa() ) return 1;
  tila=sytytetty;
  return piirra();
}

int piste::siirra(int nx, int ny)
{
  if ( !nakyvissa() ) return vaihda_paikka(nx,ny);
  sammuta();
  vaihda_paikka(nx,ny);
  return sytyta();
}


//****************************************************************************
class ympyra : public piste {
protected:
  int r;
public:
  ympyra(char *s="ympyra",int ix=0,int iy=0, int ir=1) : piste(s,ix,iy){
    r = ir;
  }
  ~ympyra() { sammuta();}
  int muuta_koko(int nr) {// Ympyrll lisksi koon muuttaminen
    if ( !nakyvissa() ) { r = nr; return 0; }
    sammuta(); r = nr; return sytyta();
  }
  int ympyra::piirra() {  // Ympyrn todellinen piirtminen
    printf("Ympyr: %-10s %-10s:(%02d,%02d) r=%d\n",Tilat[tila],nimi,x,y,r);
    return nakyvissa();
  };
};


//****************************************************************************
int main(void)
{
  printf("---------------------------------------------------------------\n");
  piste  a("a"),b("b",2,5);
  ympyra y("y",3,3);
  a.sytyta(); y.sytyta(); b.sytyta();
  a.siirra(3,3); b.siirra(); y.muuta_koko(7);
  return 0;
}
